clear all;
% compile.m should work for Linux and Mac.
% To Windows users:
% If you are using a Windows machine, please use the basic convolution (fconv.cc).
% This can be done by commenting out line 13 and uncommenting line 15 in
% compile.m
compile;

% load and visualize model
% Pre-trained model with 146 parts. Works best for faces larger than 80*80
load face_p146_small.mat

% % Pre-trained model with 99 parts. Works best for faces larger than 150*150
% load face_p99.mat

% % Pre-trained model with 1050 parts. Give best performance on localization, but very slow
% load multipie_independent.mat

disp('Model visualization');
% visualizemodel(model,1:13);
% disp('press any key to continue');
% pause;


% 5 levels for each octave
model.interval = 5;
% set up the threshold
model.thresh = min(-0.65, model.thresh);

% define the mapping from view-specific mixture id to viewpoint
if length(model.components)==13 
    posemap = 90:-15:-90;
elseif length(model.components)==18
    posemap = [90:-15:15 0 0 0 0 0 0 -15:-15:-90];
else
    error('Can not recognize this model');
end
conf.numClasses=1;

conf.calDir = 'dataset/images/' ;
mkdir('cropnewparts');
for i=1:83
    mkdir(strcat('cropnewparts/',num2str(i)));
end
c=0;
for i =553:560
   
name=strcat(conf.calDir,num2str(i));
name1=strcat(name,'.jpg');
    im = imread(name1);
%     clf; imagesc(im); axis image; axis off; drawnow;
    
    tic;
    bs = detect(im, model, model.thresh);
    bs = clipboxes(im, bs);
    bs = nms_face(bs,0.3);
    dettime = toc;
   
    c=c+1; 
    if size(bs)>0 
%         size(bs)
  for j=1:size(bs,1)
      showboxes2(im, bs(1),posemap,i);
      showboxes3(im, bs(1),posemap,i);
% showboxeslatest(im, bs(1),posemap);
  end
    end

    
    fprintf('Detection took %.1f seconds\n',dettime);

%     close all;
%     clear I;
end

disp('done!');
